Package: org.codehaus.groovy.ast

## [Java] Class CompileUnit

- org.codehaus.groovy.ast.CompileUnit

- Represents the entire contents of a compilation step which consists of one or more ModuleNode instances. There's one instance of this that's shared by all modules and classes compiled during a single invocation of the compiler.

  It's attached to MethodNodes and ClassNodes and is used to find fully qualified names of classes, resolve imports, and that sort of thing.

  Authors:
    James Strachan

- - ### Constructor Summary

    Constructors
    Constructor and description
    `CompileUnit (GroovyClassLoader classLoader, CompilerConfiguration config)`
    `CompileUnit (GroovyClassLoader classLoader, CodeSource codeSource, CompilerConfiguration config)`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `void` | `addClass(ClassNode node)` Adds a class to the unit.
    `` | `void` | `addClassNodeToCompile(ClassNode node, SourceUnit location)` this method actually does not compile a class.
    `` | `void` | `addGeneratedInnerClass(InnerClassNode icn)`
    `` | `void` | `addModule(ModuleNode node)`
    `` | `ClassNode` | `getClass(String name)` @return the ClassNode for the given qualified name or returns null if the name does not exist in the current compilation unit (ignoring the .class files on the classpath)
    `` | `GroovyClassLoader` | `getClassLoader()`
    `` | `List` | `getClasses()` @return a list of all the classes in each module in the compilation unit
    `` | `CodeSource` | `getCodeSource()`
    `` | `CompilerConfiguration` | `getConfig()`
    `` | `InnerClassNode` | `getGeneratedInnerClass(String name)`
    `` | `Map<String, InnerClassNode>` | `getGeneratedInnerClasses()`
    `` | `List<ModuleNode>` | `getModules()`
    `` | `SourceUnit` | `getScriptSourceLocation(String className)`
    `` | `boolean` | `hasClassNodeToCompile()`
    `` | `Iterator<String>` | `iterateClassNodeToCompile()`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `equals, toString, hashCode, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### public CompileUnit(GroovyClassLoader classLoader, CompilerConfiguration config)

    - #### public CompileUnit(GroovyClassLoader classLoader, CodeSource codeSource, CompilerConfiguration config)

  - ### Method Detail

    - #### public void addClass(ClassNode node)

      Adds a class to the unit.

    - #### public void addClassNodeToCompile(ClassNode node, SourceUnit location)

      this method actually does not compile a class. It's only a marker that this type has to be compiled by the CompilationUnit at the end of a parse step no node should be be left.

    - #### public void addGeneratedInnerClass(InnerClassNode icn)

    - #### public void addModule(ModuleNode node)

    - #### public ClassNode getClass(String name)

      Returns:
        the ClassNode for the given qualified name or returns null if the name does not exist in the current compilation unit (ignoring the .class files on the classpath)

    - #### public GroovyClassLoader getClassLoader()

    - #### public List getClasses()

      Returns:
        a list of all the classes in each module in the compilation unit

    - #### public CodeSource getCodeSource()

    - #### public CompilerConfiguration getConfig()

    - #### public InnerClassNode getGeneratedInnerClass(String name)

    - #### public Map<String, InnerClassNode> getGeneratedInnerClasses()

    - #### public List<ModuleNode> getModules()

    - #### public SourceUnit getScriptSourceLocation(String className)

    - #### public boolean hasClassNodeToCompile()

    - #### public Iterator<String> iterateClassNodeToCompile()